<template>
  <q-page class="flex column">
    <!-- Toolbar -->
    <q-toolbar class="bg-background-primary">
      <div class="q-gutter-x-md">
        <q-btn v-if="!app.walletConnect.isPaired.value" label="Connect Wallet" color="secondary" @click="connectWallet" />
        <q-btn v-else label="Disconnect Wallet" color="warning" @click="disconnectWallet" />
      </div>

      <q-space />

      <div class="q-gutter-x-md">
        <q-toggle
          v-if="app.walletConnect.isPaired.value"
          v-model="state.showSession"
          label="Show Session"
        />
        <q-btn label="Help" @click="app.showHelp(DocsSigner)" color="accent" />
      </div>
    </q-toolbar>

    <div class="flex row col-grow">
      <!-- Editor -->
      <div class="col">
        <!-- Main Content -->
        <div class="main-content q-gutter-y-md">
          <q-card class="bg-background-primary">
            <q-card-section>
              <h2>Wallet Connect Settings</h2>
            </q-card-section>
            <q-separator />
            <q-card-section>
              <q-form class="q-gutter-y-md">
                <p>These are the Session Proposal <i>requiredNamespaces</i> parameters that will be sent to Wallet Connect.</p>
                <p>Note that there is also a <i>template</i> parameter that will be automatically populated by this app.</p>
                <q-select label="Chains" :options="SupportedChains" v-model="signer.chains" hint="Array that maps to chains." multiple use-chips filled />
                <q-select label="Methods" :options="SupportedMethods" v-model="signer.methods" hint="Array that maps to methods." multiple use-chips filled />
                <q-select label="Events" :options="SupportedEvents" v-model="signer.events" hint="Array that maps to events." multiple use-chips filled />
                <q-select label="Allowed Token Category IDs" v-model="signer.allowedTokens" new-value-mode="add-unique" hint="(Custom) Wallet Connect will be able to request UTXO's with tokens that contain these category IDs. Array that maps to allowedTokens." use-input multiple use-chips hide-dropdown-icon filled />
              </q-form>
            </q-card-section>
          </q-card>
        </div>
      </div>

      <!-- Artifact -->
      <div v-if="state.showSession && app.walletConnect.isPaired.value" class="col">
        <div class="monaco-container">
          <vue-monaco-editor
            :value="JSON.stringify(app.walletConnect.session, null, 2)"
            theme="vs-dark"
            :options="MONACO_EDITOR_READONLY_OPTIONS"
            language="json"
            className="monaco"
          />
        </div>
      </div>
    </div>


  </q-page>
</template>

<script setup lang="ts">
import { computed, reactive, watch } from 'vue';
import { useQuasar } from 'quasar';

import { app } from '../boot/app.js';

import { SupportedChains, SupportedMethods, SupportedEvents } from 'cashconnect';

import DocsSigner from '../docs/signer.html?raw';

const $q = useQuasar();

//-----------------------------------------------------------------------------
// State
//-----------------------------------------------------------------------------

const MONACO_EDITOR_OPTIONS = {
  automaticLayout: true,
  formatOnType: true,
  formatOnPaste: true,
  language: 'javascript'
}

const MONACO_EDITOR_READONLY_OPTIONS = {
  ...MONACO_EDITOR_OPTIONS,
  readOnly: true,
}

const state = reactive({
  showSession: false,
});

const signer = computed(() => app.project.value.signer);

//-----------------------------------------------------------------------------
// Methods
//-----------------------------------------------------------------------------

async function connectWallet() {
  try {
    const namespace = {
      bch: {
        chains: signer.value.chains,
        methods: signer.value.methods,
        events: signer.value.events,
        template: app.project.value.template.template,
        allowedTokens: signer.value.allowedTokens,
      }
    }

    await app.walletConnect.pair(namespace);

    state.showSession = true;
  } catch(error: any) {
    console.log(error);

    $q.notify({
      color: 'negative',
      message: error.message
    });
  }
}

async function disconnectWallet() {
  try {
    await app.walletConnect.disconnect();
  } catch(error: any) {
    console.log(error);

    $q.notify({
      color: 'negative',
      message: error.message
    });
  }
}

//-----------------------------------------------------------------------------
// Watchers
//-----------------------------------------------------------------------------

// If our signer settings change, disconnect the session.
watch(signer.value, async () => {
  if(app.walletConnect.isPaired.value) {
    await app.walletConnect.disconnect();

    // Notify user.
    $q.notify({ type: 'warning', message: 'Wallet Connect settings have changed! You will need to reconnect your WalletConnect session.' });
  }
});

//-----------------------------------------------------------------------------
// Initialization/Lifecycle
//-----------------------------------------------------------------------------

if(app.walletConnect.isPaired.value) {
  state.showSession = true;
}
</script>
